SystemOrganization addCategory: #'Codex-Tests'!
SystemOrganization addCategory: #'Codex-Parser'!
SystemOrganization addCategory: #'Codex-Interpreter'!
SystemOrganization addCategory: #'Codex-Model'!

TestCase subclass: #CXGrammarTest
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Tests'!

!CXGrammarTest methodsFor: 'parsing' stamp: 'cwp 12/23/2009 02:00'!
parse: aString rule: aSymbol 
	| production |
	production := self parser.
	aSymbol = #start 
		ifFalse: [ production := production instVarNamed: aSymbol ].
	result := production end
		parse: aString asParserStream.
	self 
		deny: result isFailure
		description: 'Unable to parse ' , aString printString! !

!CXGrammarTest methodsFor: 'accessing' stamp: 'cwp 12/23/2009 02:01'!
parser
	^ PPGrammarResource current parserAt: self parserClass! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:44'!
parserClass
	^ CXParser! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:30'!
testCapital
	self parse: 'Alias' rule: #label.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:31'!
testDash
	self parse: 'nurp-griffle' rule: #label.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:19'!
testDirective
	self parse: 'package Nurp' rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/21/2009 23:40'!
testDirectiveWithBlankLine
	self 
		parse: 'keyword la-bel {
	keyword2 Label2
	
	keyword3 Label3
}' 
		rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:42'!
testDirectiveWithLabel
	self parse: 'keyword Label1 Label2' rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:43'!
testDirectiveWithList
	self parse: 'keyword Label1 (Label2 Label3)' rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:43'!
testDirectiveWithList2
	self parse: 'keyword Label1 (
		Label2 
		Label3
)' rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/21/2009 23:02'!
testDirectiveWithMultisection
	self 
		parse: 'keyword la-bel {
	keyword2 Label2
	keyword3 Label3
}' 
		rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:16'!
testDirectiveWithScope
	self parse: 'keyword Label1 {keyword2 Label2}' rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:29'!
testKeyword
	self parse: 'alias' rule: #keyword.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:26'!
testListInline
	self parse: '(Label1 Label2)' rule: #listValue.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:26'!
testListMultiline
	self parse: '(
	Label1
	Label2
)' rule: #listValue.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:24'!
testScope0
	self parse: '{}' rule: #scopeValue.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:24'!
testScope1
	self parse: '{package Nurp}' rule: #scopeValue.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:25'!
testScope1Multiline
	self parse: '{
	package Nurp
}' rule: #scopeValue.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:25'!
testScope2Multiline
	self parse: '{
	package Nurp
	package Griffle
}' rule: #scopeValue.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:16'!
testScopeDirective
	self parse: 'package Gooly {package Nurp}' rule: #directive.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:24'!
testScopeEmpty
	self parse: '' rule: #scope.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:32'!
testUnderscore
	self parse: 'nurp_griffle' rule: #label.
	! !

!CXGrammarTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:33'!
testUrl
	self parse: 'http://www.squeak.org/download.html' rule: #label.
	! !

TestCase subclass: #CXInterpreterTest
	instanceVariableNames: 'codex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Tests'!

!CXInterpreterTest methodsFor: 'running' stamp: 'cwp 12/26/2009 12:17'!
interpret: aString 
	| node |
	codex := CXCodex new.
	node := CXParser parse: aString.
	(CXRootInterpreter on: codex) interpret: node! !

!CXInterpreterTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/26/2009 12:17'!
testDepenencies
	| cx2 group |
	self interpret: 
'package Cx1
package Cx2
dependencies Cx1 (Cx2)
'.
	
	self assert: codex packages size = 3.
	cx2 := codex packageNamed: 'Cx2'.
	group := codex packageNamed: 'Codex'.
	self assert: (group packages includes: cx2).
	self assert: (cx2 isForeign)! !

!CXInterpreterTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/26/2009 12:18'!
testGroup
	| cx1 cx2 group |
	self interpret: 
'package Cx1
package Cx2
group Codex (Cx1 Cx2)
'.
	
	self assert: codex packages size = 3.
	cx1 := codex packageNamed: 'Cx1'.
	cx2 := codex packageNamed: 'Cx1'.
	group := codex packageNamed: 'Codex'.
	self assert: (group packages includes: cx1).
	self assert: (group packages includes: cx2).
	! !

!CXInterpreterTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/26/2009 12:18'!
testGroupForeign
	| cx2 group |
	self interpret: 
'package Cx1
group Codex (Cx1 Cx2)
'.
	self assert: codex packages size = 3.
	cx2 := codex packageNamed: 'Cx2'.
	group := codex packageNamed: 'Codex'.
	self assert: (group packages includes: cx2).
	self assert: (cx2 isForeign)! !

!CXInterpreterTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/26/2009 12:18'!
testPackage
	self interpret: 'package Codex'.
	self assert: codex packages size = 1.
	self assert: codex packages anyOne name = 'Codex' ! !

TestCase subclass: #CXParserTest
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Tests'!

!CXParserTest methodsFor: 'support' stamp: 'cwp 12/22/2009 10:29'!
mc2Codex
	^ 'import Grease
import OmniBrowser

repository wiresong-mc http://source.wiresong.ca/mc

package MC2-Squeak-Platform
package MC2-Core
package MC2-Smalltalk
package MC2-Export-Chunk
package MC2-Repository-File
package MC2-Repository-Directory
package MC2-Repository-Network
package MC2-Meta-Core
package MC2-Meta-Repository-File
package MC2-Meta-Repository-Directory
package MC2-Meta-Repository-Network
package MC2-OmniBrowser
package MC2-Tests-Core
package MC2-Tests-Export-Chunk
package MC2-Tests-Repository-File
package MC2-Tests-Repository-Directory
package MC2-Tests-Repository-Network
package MC2-Tests-OmniBrowser
package MC2-Tests-Meta-Core
package MC2-Tests-Meta-Repository-File
package MC2-Tests-Meta-Repository-Directory
package MC2-Tests-Meta-Repository-Network

group DEFAULT (
	MC2-Squeak-Platform
	MC2-Core
	MC2-Smalltalk
	MC2-Squeak-Smalltalk
	MC2-Export-Chunk
	MC2-Repository-File
	MC2-Repository-Directory
	MC2-Repository-Network
	MC2-OmniBrowser
	MC2-Meta-Core
	MC2-Meta-Squeak-Smalltalk
	MC2-Meta-Repository-File
	MC2-Meta-Repository-Directory
	MC2-Meta-Repository-Network
)

group Tests (
	MC2-Tests-Core
	MC2-Tests-Export-Chunk
	MC2-Tests-Smalltalk
	MC2-Tests-Squeak-Smalltalk
	MC2-Tests-Repository-File
	MC2-Tests-Repository-Directory
	MC2-Tests-Repository-Network
	MC2-Tests-Meta-Core
	MC2-Tests-OmniBrowser
	MC2-Tests-Meta-Squeak-Smalltalk
	MC2-Tests-Meta-Repository-File
	MC2-Tests-Meta-Repository-Directory
	MC2-Tests-Meta-Repository-Network
)

dependencies MC2-Core (
	Grease-Core
	Grease-Pharo-Core
	MC2-Platform
)

dependencies MC2-Smalltalk (MC2-Core)
dependencies MC2-Squeak-Smalltalk (MC2-Smalltalk)

dependencies MC2-Export-Chunk (
	MC2-Core 
	MC2-Smalltalk
)

dependencies MC2-Repository-File (MC2-Core)
dependencies MC2-Repository-Directory (MC2-Repository-File)
dependencies MC2-Repository-Network (MC2-Core)
dependencies MC2-Meta-Core (MC2-Core)

dependencies MC2-Meta-Squeak-Smalltalk (
	MC2-Meta-Core 
	MC2-Squeak-Smalltalk
)

dependencies MC2-Meta-Repository-File (
	MC2-Meta-Core 
	MC2-Repository-File
)

dependencies MC2-Meta-Repository-Directory (
	MC2-Meta-Core 
	MC2-Repository-Directory
)

dependencies MC2-Meta-Repository-Network (
	MC2-Meta-Core 
	MC2-Repository-Network
)

dependencies MC2-OmniBrowser (
	MC2-Core 
	OmniBrowser 
	OB-Morphic
)

dependencies MC2-Tests-Core (MC2-Core)
dependencies MC2-Tests-Export-Chunk (MC2-Export-Chunk)

dependencies MC2-Tests-Smalltalk (
	MC2-Tests-Core
	MC2-Smalltalk 
	MC2-Meta-Core
)

dependencies MC2-Tests-Squeak-Smalltalk (
	MC2-Tests-Core 
	MC2-Tests-Smalltalk 
	MC2-Squeak-Smalltalk
)

dependencies MC2-Tests-Repository-File (
	MC2-Tests-Core 
	MC2-Repository-File
)

dependencies MC2-Tests-Repository-Directory (
	MC2-Tests-Core 
	MC2-Repository-Directory
)

dependencies MC2-Tests-Repository-Network (
	MC2-Tests-Core 
	MC2-Repository-Network 
	MockLibrary
)

dependencies MC2-Tests-OmniBrowser (
	MC2-OmniBrowser MC2-Squeak-Smalltalk 
	MC2-Repository-Directory 
	MC2-Repository-File
	MC2-Repository-Network
	MC2-Tests-Meta-Core
	OB-Tests-Core 
)

dependencies MC2-Tests-Meta-Core (
	MC2-Tests-Core 
	MC2-Meta-Core
)

dependencies MC2-Tests-Meta-Squeak-Smalltalk (
	MC2-Tests-Meta-Core 
	MC2-Meta-Squeak-Smalltalk
)

dependencies MC2-Tests-Meta-Repository-File (
	MC2-Tests-Meta-Core 
	MC2-Meta-Repository-File
)

dependencies MC2-Tests-Meta-Repository-Directory (
	MC2-Tests-Meta-Core 
	MC2-Meta-Repository-Directory
)

dependencies MC2-Tests-Meta-Repository-Network (
	MC2-Tests-Meta-Core 
	MC2-Meta-Repository-Network
)

section squeak-common {
	platform squeak
	platform pharo
	
	alias MC2-Platform MC2-SqueakPlatform
	package MC2-Squeak-Smalltalk
	package MC2-Meta-Squeak-Smalltalk
	package MC2-Tests-Squeak-Smalltalk
	package MC2-Tests-Meta-Squeak-Smalltalk	
}

section baseline-1 {
	version MC2-SqueakPlatform MC2-SqueakPlatform-cwp.37
	version MC2-Core MC2-Core-cwp.14
	version MC2-Smalltalk MC2-Smalltalk-jf.1
	version MC2-Squeak-Smalltalk MC2-Squeak-Smalltalk-cwp.12
	version MC2-Export-Chunk MC2-Export-Chunk-jf.2
	version MC2-Repository-File MC2-Repository-File-cwp.4
	version MC2-Repository-Directory MC2-Repository-Directory-jf.2
	version MC2-Repository-Network MC2-Repository-Network-cwp.3
	version MC2-Meta-Core MC2-Meta-Core-jf.4
	version MC2-Meta-Squeak-Smalltalk MC2-Meta-Squeak-Smalltalk-cwp.1
	version MC2-Meta-Repository-File MC2-Meta-Repository-File-cwp.1
	version MC2-Meta-Repository-Directory MC2-Meta-Repository-Directory-cwp.1
	version MC2-Meta-Repository-Network MC2-Meta-Repository-Network-cwp.1
	version MC2-OmniBrowser MC2-OmniBrowser-jf.4
	version MC2-Tests-Core MC2-Tests-Core-cwp.16
	version MC2-Tests-Export-Chunk MC2-Tests-Export-Chunk-cwp.2
	version MC2-Tests-Smalltalk MC2-Tests-Smalltalk-cwp.4
	version MC2-Tests-Squeak-Smalltalk MC2-Tests-Squeak-Smalltalk-cwp.10
	version MC2-Tests-Repository-File MC2-Tests-Repository-File-cwp.1
	version MC2-Tests-Repository-Directory MC2-Tests-Repository-Directory-jf.2
	version MC2-Tests-Repository-Network MC2-Tests-Repository-Network-jf.2
	version MC2-Tests-OmniBrowser MC2-Tests-OmniBrowser-cwp.1
	version MC2-Tests-Meta-Core MC2-Tests-Meta-Core-cwp.5
	version MC2-Tests-Meta-Squeak-Smalltalk MC2-Tests-Meta-Squeak-Smalltalk-cwp.2
	version MC2-Tests-Meta-Repository-File MC2-Tests-Meta-Repository-File-jf.1
	version MC2-Tests-Meta-Repository-Directory MC2-Tests-Meta-Repository-Directory-jf.1
	version MC2-Tests-Meta-Repository-Network MC2-Tests-Meta-Repository-Network-jf.1
	version MockLibrary MockLibrary-cwp.7
}

section baseline-2 {
	include baseline-1
	version MC2-Core MC2-Core-cwp.15
}

release 2.1.0 {
	blessing alpha
	include baseline-1
	include squeak-common
}

release 2.1.1 {
	blessing beta
	include baseline-2
	include squeak-common
}
'! !

!CXParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:59'!
parseDirective: aString 
	| production |
	production := CXParser new instVarNamed: #directive.
	result := production parse: aString asParserStream.
	self 
		deny: result isFailure
		description: 'Unable to parse ' , aString printString.
	^ result! !

!CXParserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 02:00'!
parseScope: aString
	result := CXParser parse: aString asParserStream.
	self 
		deny: result isFailure
		description: 'Unable to parse ' , aString printString.
	^ result! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/25/2009 09:21'!
testAlias
	| directive |
	directive := self parseDirective: 'alias Nurp Griffle'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive keyword = #alias.
	self assert: directive name value = 'Nurp'.
	self assert: directive value value = 'Griffle'.! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/23/2009 01:59'!
testExample
	self parseScope: self mc2Codex.
	! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/25/2009 09:23'!
testGroupOne
	| directive |
	directive := self parseDirective: 'group Nurp (Griffle)'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive keyword = #group.
	self assert: directive name value = 'Nurp'.
	self assert: directive value names = #('Griffle' )! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/25/2009 09:23'!
testGroupTwo
	| directive |
	directive := self parseDirective: 'group Nurp (Griffle Plonk)'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive keyword = #group.
	self assert: directive name value = 'Nurp'.
	self assert: directive value names = #('Griffle' 'Plonk' )! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/25/2009 09:25'!
testGroupZero
	| directive |
	directive := self parseDirective: 'group Nurp ()'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive keyword = #group.
	self assert: directive name value = 'Nurp'.
	self assert: directive value names = #()! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/25/2009 09:23'!
testPackageName
	| directive |
	directive := self parseDirective: 'package Nurp'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive keyword = #package.
	self assert: directive name value = 'Nurp'! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/25/2009 09:23'!
testScopeEmpty
	| directive |
	directive := self parseDirective: 'group Nurp {}'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive keyword = #group.
	self assert: directive name value = 'Nurp'.
	self assert: (directive value isKindOf: CXScope).
	self assert: directive value directives isEmpty! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/25/2009 09:25'!
testScopeOne
	| directive |
	directive := self parseDirective: 'group Nurp {package Plonk}'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive keyword = #group.
	self assert: directive name value = 'Nurp'.
	self assert: (directive value isKindOf: CXScope).
	self assert: directive value directives size = 1.
	self assert: directive value directives first name value = 'Plonk'! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/25/2009 09:25'!
testScopeTwo
	| directive text |
	text := 'group Nurp {
		package Plonk 
		package Griffle
	}'.
	directive := self parseDirective: text.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive keyword = #group.
	self assert: directive name value = 'Nurp'.
	self assert: (directive value isKindOf: CXScope).
	self assert: directive value directives size = 2.
	self assert: directive value directives first name value = 'Plonk'.
	self assert: directive value directives second name value = 'Griffle'! !

!CXParserTest methodsFor: 'tests' stamp: 'cwp 12/25/2009 09:25'!
testScopeTwoLowercase
	| directive |
	directive := self parseDirective: 'group nurp {
	package Plonk 
	package Griffle
}'.
	self assert: (directive isKindOf: CXDirective).
	self assert: directive keyword = #group.
	self assert: directive name value = 'nurp'.
	self assert: (directive value isKindOf: CXScope).
	self assert: directive value directives size = 2.
	self assert: directive value directives first name value = 'Plonk'.
	self assert: directive value directives second name value = 'Griffle'! !

PPTokenParser subclass: #CXTokenParser
	instanceVariableNames: 'spaces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXTokenParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 00:37'!
consumeSpaces: aStream
	[ aStream atEnd not and: [ spaces includes: aStream peek  ] ]
		whileTrue: [ aStream next ]! !

!CXTokenParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:18'!
initialize
	spaces := String new: 2.
	spaces at: 1 put: Character space.
	spaces at: 2 put: Character tab.! !

Object subclass: #CXCodex
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Model'!

!CXCodex methodsFor: 'as yet unclassified' stamp: 'cwp 12/26/2009 11:27'!
addPackage: aPackage
	^ packages add: aPackage! !

!CXCodex methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:36'!
initialize
	packages := Set new! !

!CXCodex methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 14:13'!
packageNamed: aString
	^ self packageNamed: aString ifAbsent: [nil]! !

!CXCodex methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 14:11'!
packageNamed: aString ifAbsent: aBlock
	^ packages 
		detect: [:ea | ea name = aString] 
		ifNone: aBlock! !

!CXCodex methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:38'!
packages
	^ packages! !

Object subclass: #CXDirective
	instanceVariableNames: 'name value keyword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXDirective class methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:27'!
keyword: aSymbol name: aString 
	^ self 
		keyword: aSymbol
		name: aString
		value: nil! !

!CXDirective class methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:27'!
keyword: aSymbol name: aString value: anObject 
	^ self basicNew 
		initializeWithKeyword: aSymbol
		name: aString
		value: anObject! !

!CXDirective methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:22'!
initializeWithKeyword: aSymbol name: aString value: anObject 
	keyword := aSymbol.
	name := aString.
	value := anObject! !

!CXDirective methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:34'!
interpretedBy: anObject
	^ anObject interpretDirective: self! !

!CXDirective methodsFor: 'accessing' stamp: 'cwp 12/25/2009 09:23'!
keyword
	^ keyword! !

!CXDirective methodsFor: 'accessing' stamp: 'cwp 12/16/2009 21:21'!
name
	^ name! !

!CXDirective methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:22'!
printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: keyword;
		space;
		nextPutAll: name value;
		nextPut: $)! !

!CXDirective methodsFor: 'accessing' stamp: 'cwp 12/16/2009 21:21'!
value
	^ value! !

Object subclass: #CXInterpreter
	instanceVariableNames: 'codex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Interpreter'!

!CXInterpreter class methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:15'!
new
	^ self on: CXCodex new! !

!CXInterpreter class methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:14'!
on: aCodex
	^ self basicNew initializeWithCodex: aCodex! !

!CXInterpreter methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:37'!
codex
	^ codex! !

!CXInterpreter methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:14'!
initializeWithCodex: aCodex
	codex := aCodex! !

CXInterpreter subclass: #CXRootInterpreter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Interpreter'!

!CXRootInterpreter methodsFor: 'keywords' stamp: 'cwp 12/26/2009 11:25'!
group
	^ 
	[ :name :value | 
	| group |
	group := CXGroup name: name.
	codex addPackage: group.
	value names do: 
		[ :ea || pkg |
		pkg := codex 
			packageNamed: ea
			ifAbsent: [ codex addPackage: (CXForeignPackage name: ea) ].
		group addPackage: pkg ] ]! !

!CXRootInterpreter methodsFor: 'interpreting' stamp: 'cwp 12/25/2009 09:34'!
interpret: anObject
	anObject interpretedBy: self! !

!CXRootInterpreter methodsFor: 'interpreting' stamp: 'cwp 12/25/2009 09:34'!
interpretDirective: aDirective
	(self perform: aDirective keyword)
		value: aDirective name value
		value: aDirective value! !

!CXRootInterpreter methodsFor: 'interpreting' stamp: 'cwp 12/25/2009 13:08'!
interpretScope: aScope
	aScope directives do: [:ea | self interpret: ea]! !

!CXRootInterpreter methodsFor: 'keywords' stamp: 'cwp 12/25/2009 09:16'!
package
	^ [:name :value | codex addPackage: (CXPackage name: name)]! !

Object subclass: #CXLabel
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXLabel class methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 02:09'!
on: aString
	^ self basicNew initializeWithString: aString! !

!CXLabel methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 07:02'!
accept: aVisitor
	aVisitor visitLabel: self.! !

!CXLabel methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 02:09'!
initializeWithString: aString
	self initialize.
	value := aString! !

!CXLabel methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 06:58'!
printOn: aStream
	super printOn: aStream.
	aStream 
		nextPut: $(;
		nextPutAll: value;
		nextPut: $)! !

!CXLabel methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 02:11'!
value
	^ value! !

Object subclass: #CXList
	instanceVariableNames: 'labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXList class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2009 21:13'!
new
	^ self withAll: Array new! !

!CXList class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2009 21:07'!
with: aString
	^ self withAll: (Array with: aString)! !

!CXList class methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 02:12'!
withAll: anArray 
	^ self basicNew initializeWithLabels: anArray! !

!CXList methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 07:13'!
accept: aVisitor
	aVisitor 
		visitList: self
		during: [labels do: [:ea | aVisitor visit: ea]]! !

!CXList methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 02:13'!
initializeWithLabels: anArray 
	self initialize.
	labels := anArray! !

!CXList methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 02:13'!
labels
	^ labels! !

!CXList methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 02:13'!
names
	^ labels collect: [:ea | ea value]! !

Object subclass: #CXPackage
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Model'!

CXPackage subclass: #CXForeignPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Model'!

!CXForeignPackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 14:22'!
isForeign
	^ true! !

CXPackage subclass: #CXGroup
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Model'!

!CXGroup methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 14:12'!
addPackage: aPackage
	packages add: aPackage! !

!CXGroup methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 14:15'!
addPackagesTo: aSet
	aSet addAll: packages.
	^ aSet! !

!CXGroup methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 14:12'!
initializeWithName: aString
	super initializeWithName: aString.
	packages := Set new.! !

!CXPackage class methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:35'!
name: aString
	^ self basicNew initializeWithName: aString! !

!CXPackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 14:15'!
addPackagesTo: aSet
	aSet add: self.
	^ aSet! !

!CXPackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:35'!
initializeWithName: aString
	self initialize.
	name := aString! !

!CXPackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 14:22'!
isForeign
	^ false! !

!CXPackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:38'!
name
	^ name! !

!CXPackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 14:14'!
packages
	^ self addPackagesTo: Set new! !

!CXPackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/26/2009 11:18'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: name;
		nextPut: $)! !

Object subclass: #CXScope
	instanceVariableNames: 'directives'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXScope class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 23:41'!
directives: anArray
	^ self basicNew initializeWithDirectives: anArray! !

!CXScope class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 23:41'!
new
	^ self directives: Array new! !

!CXScope class methodsFor: 'as yet unclassified' stamp: 'cwp 12/16/2009 23:41'!
with: aDirective
	^ self directives: (Array with: aDirective)! !

!CXScope methodsFor: 'accessing' stamp: 'cwp 12/16/2009 23:44'!
addDirective: aDirective
	directives := directives copyWith: aDirective! !

!CXScope methodsFor: 'accessing' stamp: 'cwp 12/16/2009 22:17'!
directives
	^ directives! !

!CXScope methodsFor: 'accessing' stamp: 'cwp 12/16/2009 23:42'!
initializeWithDirectives: anArray
	self initialize.
	directives := anArray! !

!CXScope methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 13:07'!
interpretedBy: anObject
	^ anObject interpretScope: self! !

PPCompositeParser subclass: #CXGrammar
	instanceVariableNames: 'eol directive keyword value label whitespace scopeValue scope listValue list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXGrammar class methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 22:19'!
ignoredNames
	^ super ignoredNames, #(name)! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/19/2009 21:40'!
directive
	^ keyword, label, value optional! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 00:56'!
eol
	^ #newline asParser plus! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 21:58'!
keyword
	^ #lowercase asParser plus token! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 00:56'!
label
	^ (#word asParser / (PPPredicateParser anyOf: '.-_/:')) plus token! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:21'!
list
	^ eol optional, (label, eol optional) star! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:21'!
listValue
	^ $( asParser , list , $) asParser! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:23'!
scope
	^ eol optional, (directive separatedBy: eol token plus) optional, eol optional! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:22'!
scopeValue
	^ ${ asParser token , scope , $} asParser token! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:18'!
start
	^ (scope , whitespace optional) end! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 00:55'!
tokenParser
	^ CXTokenParser! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:30'!
value
	^ label / listValue / scopeValue! !

!CXGrammar methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2009 23:45'!
whitespace
	^ #space asParser plus! !

CXGrammar subclass: #CXParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Codex-Parser'!

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2009 09:31'!
directive
	^ super directive ==> 
		[ :nodes | 
		CXDirective 
			keyword: nodes first value asSymbol
			name: nodes second
			value: nodes third ]! !

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 02:08'!
label
	^ super label ==> [:tokens | CXLabel on: tokens value]! !

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 02:11'!
list
	^ super list ==>
		[:nodes | 
		Array streamContents:
			[:out |
			(nodes at: 2) do:
				[:pair |
				out nextPut: pair first]]]! !

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:45'!
listValue
	^ super listValue ==> [:nodes | CXList withAll: nodes second]! !

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:26'!
scope
	| directives |
	^ super scope ==> 
		[ :nodes | 
		directives := nodes at: 2.
		CXScope directives: (directives 
				ifNil: 
					[ #() ]
				ifNotNil: [ directives select: [ :ea | ea class = CXDirective ] ]) ]! !

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/23/2009 01:26'!
scopeValue
	^ super scopeValue ==> [:nodes | nodes second]! !

!CXParser methodsFor: 'as yet unclassified' stamp: 'cwp 12/22/2009 23:02'!
start
	^ super start ==> [:nodes | nodes first]! !
